/******************************************************************************
*******************************************************************************
**                                                                           **
**      C Swing - A graphical file and directory maintenance utility         **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: S. J. Brown                                    **
**                                                                           **
**      Modifications by many others; see the documentation for a list       **
**                                                                           **
**      Copyright 1994, Harry Flowers and Foteos Macrides                    **
**                                                                           **
**      Terms of Copyright:  This software may be freely distributed         **
**          and used by anyone, providing the distributor provides it        **
**          free of charge or at a price which only covers distribution      **
**          costs.  It may not be sold.  Note that versions prior to         **
**          V3.7.4 were public domain, and are not subject to these terms.   **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
 
/*
**	Here are some shorthands for VMS structures as used in C
**	Use of each is as follows
**
** 	$DESCRIPTORl is used for single char items or structures
** 	$DESCRIPTORM is used for strings which are not necessarilly
**	terminated by the null character
** 	$DESCRIPTORA is used for arrays
** 	$DESCRIPTORI is used for a single integer
**
**	DSC1, DSC2, DSC3 are shorthands for use in C code
**	DSCP is for pointers to null terminated strings
**
**	for DSC1, DSC2, DSC3
**	use e.g. DSC1("here is a test string")
**
**	for DSCP
**	use e.g. 
**
**	char *ptr;
**	DSCP(ptr)
**
**	mandatory include of descrip.h (in sys$library) if it's not yet
**	been included
*/

#ifndef DSC$K_DTYPE_T
#include <descrip.h>
#endif

#define $DESCRIPTORl(nam,str)	struct dsc$descriptor_s \
nam = { sizeof(str), DSC$K_DTYPE_T, DSC$K_CLASS_S, &str }

#define $DESCRIPTORM(nam,str)	struct dsc$descriptor_s \
nam = { sizeof(str), DSC$K_DTYPE_T, DSC$K_CLASS_S, str }

#define $DESCRIPTORI(nam,var)	struct dsc$descriptor_s \
nam = { sizeof(var), DSC$K_DTYPE_L, DSC$K_CLASS_S, &var}

#define $DESCRIPTORA(nam,arr,type)	struct dsc$descriptor_a \
nam = { sizeof (type), DSC$K_DTYPE_L, DSC$K_CLASS_A, arr, \
0, 0, { 0, 0, 0, 0, 0 }, 1, sizeof arr }

#define _MLEN(des)	des.dsc$w_length
#define _MPTR(des)	des.dsc$a_pointer

static	struct	dsc$descriptor_s
	_tmp_descr_1 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_2 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_3 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_4 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_5 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_6 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_p = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_p1= { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_p2= { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_p3= { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_a = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_a1= { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_a2= { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
	_tmp_descr_a3= { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 };

#define DSC1(str) (_MLEN (_tmp_descr_1) = strlen (str),\
 _MPTR (_tmp_descr_1) = str, &_tmp_descr_1)

#define DSC2(str) (_MLEN (_tmp_descr_2) = strlen (str),\
 _MPTR (_tmp_descr_2) = str, &_tmp_descr_2)

#define DSC3(str) (_MLEN (_tmp_descr_3) = strlen (str),\
 _MPTR (_tmp_descr_3) = str, &_tmp_descr_3)

#define DSC4(str) (_MLEN (_tmp_descr_4) = strlen (str),\
 _MPTR (_tmp_descr_4) = str, &_tmp_descr_4)

#define DSC5(str) (_MLEN (_tmp_descr_5) = strlen (str),\
 _MPTR (_tmp_descr_5) = str, &_tmp_descr_5)

#define DSC6(str) (_MLEN (_tmp_descr_6) = strlen (str),\
 _MPTR (_tmp_descr_6) = str, &_tmp_descr_6)

#define DSCP(ptr) (_MLEN (_tmp_descr_p) = strlen (ptr),\
 _MPTR (_tmp_descr_p) = ptr, &_tmp_descr_p)

#define DSCP1(ptr) (_MLEN (_tmp_descr_p1) = strlen (ptr),\
 _MPTR (_tmp_descr_p1) = ptr, &_tmp_descr_p1)

#define DSCP2(ptr) (_MLEN (_tmp_descr_p2) = strlen (ptr),\
 _MPTR (_tmp_descr_p2) = ptr, &_tmp_descr_p2)

#define DSCP3(ptr) (_MLEN (_tmp_descr_p3) = strlen (ptr),\
 _MPTR (_tmp_descr_p3) = ptr, &_tmp_descr_p3)

#define DSCA(str) (_MLEN (_tmp_descr_a) = sizeof (str),\
 _MPTR (_tmp_descr_a) = str, &_tmp_descr_a)

#define DSCA1(str) (_MLEN (_tmp_descr_a1) = sizeof (str),\
 _MPTR (_tmp_descr_a1) = str, &_tmp_descr_a1)

#define DSCA2(str) (_MLEN (_tmp_descr_a2) = sizeof (str),\
 _MPTR (_tmp_descr_a2) = str, &_tmp_descr_a2)

#define DSCA3(str) (_MLEN (_tmp_descr_a3) = sizeof (str),\
 _MPTR (_tmp_descr_a3) = str, &_tmp_descr_a3)

