/******************************************************************************
*******************************************************************************
**                                                                           **
**      C Swing - A graphical file and directory maintenance utility         **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: S. J. Brown                                    **
**                                                                           **
**      Modifications by many others; see the documentation for a list       **
**                                                                           **
**      Copyright 1994, Harry Flowers and Foteos Macrides                    **
**                                                                           **
**      Terms of Copyright:  This software may be freely distributed         **
**          and used by anyone, providing the distributor provides it        **
**          free of charge or at a price which only covers distribution      **
**          costs.  It may not be sold.  Note that versions prior to         **
**          V3.7.4 were public domain, and are not subject to these terms.   **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
 
/*
**  swing_18.c
*/
#include <stdio.h>
#include <string.h>
#include <lnmdef.h>
#include <descrip.h>
#include <ssdef.h>
#include <psldef.h>
#include <rms.h>
#include <starlet.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

ULONG translate(char *string, char *res)
{
    ULONG  status;
    int    attr;

    struct dsc$descriptor_s tabnam,lognam;

    ITM_LST itmlst[2];

    USHORT  result = 0;
    char *lnm = "LNM$FILE_DEV";
    unsigned char acmode;


    res[0] = 0;

    lognam.dsc$w_length  = strlen(string);
    lognam.dsc$a_pointer = string;
    lognam.dsc$b_class   = DSC$K_CLASS_S;
    lognam.dsc$b_dtype   = DSC$K_DTYPE_T;

    tabnam.dsc$w_length  = strlen(lnm);
    tabnam.dsc$a_pointer = lnm;
    tabnam.dsc$b_class   = DSC$K_CLASS_S;
    tabnam.dsc$b_dtype   = DSC$K_DTYPE_T;

    itmlst[0].buffer_length = 100;
    itmlst[0].item_code     = LNM$_STRING;
    itmlst[0].buffer_address = res;
    itmlst[0].return_length_address = &result;
    itmlst[1].buffer_length = itmlst[1].item_code     = 0; 

    attr = LNM$M_CASE_BLIND;

    acmode = PSL$C_USER;

    status = sys$trnlnm(&attr ,
    			&tabnam,
                        &lognam,
                        &acmode,
                        &itmlst);

    if((status & 1) == 1)
       res[result] = 0;
 
   return(status);
}
