/******************************************************************************
*******************************************************************************
**                                                                           **
**      C Swing - A graphical file and directory maintenance utility         **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: S. J. Brown                                    **
**                                                                           **
**      Modifications by many others; see the documentation for a list       **
**                                                                           **
**      Copyright 1994, Harry Flowers and Foteos Macrides                    **
**                                                                           **
**      Terms of Copyright:  This software may be freely distributed         **
**          and used by anyone, providing the distributor provides it        **
**          free of charge or at a price which only covers distribution      **
**          costs.  It may not be sold.  Note that versions prior to         **
**          V3.7.4 were public domain, and are not subject to these terms.   **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
 
/*
**  swing_32.c - return checksum for a directory
*/
#include <stdio.h>
#include <stdlib.h>
#include <ssdef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

ULONG get_checksum(NODE *n)
{
    char file[SPEC_SIZE+1];
    long status, i, to_check, blocks;
    unsigned long *buffer;
    unsigned long checksum;

    buffer = (ULONG *) read_a_directory(n,&blocks);
    if (!buffer)
        return(FALSE);

    to_check = blocks * 128;

    checksum = 0;
    for (i = 0; i < to_check; i++)
    {
        /*
        **  add this character
        */
        checksum = (checksum ^ buffer[i]);
    }
    free(buffer);
    return(checksum);
}
